unit AF_Unit;

{This unit has functions and constants the Aliens Force program needs that
 are not associated w/ on of the object in the program}

interface

uses crt, dos, memory, Coords, Colors;

const
  SC_WIDTH = 80; {SC --> screen}
  SC_HEIGHT = 25;
  SC_VERT_CENTER = SC_HEIGHT div 2;
  SC_HORZ_CENTER = SC_WIDTH div 2;

  GM_LEFT = 2; {GM --> game}
  GM_RIGHT = (SC_WIDTH - GM_LEFT + 1) div 2 * 2; {div 2 * 2 makes it even}
  GM_TOP = 2;
  GM_BOT = (SC_HEIGHT - GM_TOP + 1) div 2 * 2;

  GM_MAX_STAGE = CL_WHITE; {A stage for every color}
  GM_MAX_ALIEN_COUNT = 5;
  GM_MAX_BULLETS = 3;

  GM_WALL = #219;
  GM_SPACE = #32;

  VK_ESC = #27; {VK --> Virtual Key}
  VK_NULL = #0;
  VK_SPACE = #32;
  VK_UP = 'H';
  VK_DOWN = 'P';
  VK_LEFT = 'K';
  VK_RIGHT = 'M';

  function GetKey : char;
  function Timer : real;
  function Sleep (SleepFor : real) : char;
  procedure CenterX (s : string; yCord : TCoord);
  function ChangeCursor (on : boolean) : boolean;

implementation

function GetKey : char;
begin
  {Works like QBasic's INKEY$ function; returns the key pressed if one has
   been pressed and VK_NULL otherwise}
  if KeyPressed then
    GetKey := ReadKey
  else
    GetKey := VK_NULL;
end;

function Timer : real;
var Hour, Min, Sec, Hund : word;
begin
  {Returns the time according to get time in units of seconds ingnoring
   the Hours because they make the real value overflow and are not needed
   for measuring differences b/t short time intervale}
  GetTime (Hour, Min, Sec, Hund);
  Timer := Min * 60 + Sec + Hund / 100;
end;

function Sleep (SleepFor : real) : char;
var Start : real;
begin
  {This function Sleeps for SleepFor seconds unless a Key is pressed first;
   if a Key is pressed, it is returned, otherwise VK_NULL is returned}
  Start := Timer;
  while (Timer - Start < SleepFor) and not KeyPressed do;

  Sleep := GetKey;
end;

procedure CenterX (s : string; yCord : TCoord);
begin
  {Prints s in the horizontal center of the screen and vertically at yCord}
  gotoxy (SC_HORZ_CENTER - length (s) div 2, yCord);
  write (s);
end;

function ChangeCursor (on : boolean) : boolean;
begin
  {cursor.exe on turns the cursor on and cursor.exe off turns the cursor
   off}
  if on then
    Exec ('cursor.exe', 'on')
  else {not on or off}
    Exec ('cursor.exe', 'off');

  {returns true only if cursor was changed}
  if DosError = 0 then
    ChangeCursor := true
  else begin
    write ('Dos Error #', DosError, ' occured while trying to run cursor.exe');
    sleep (2);
    ChangeCursor := false;
  end;
end;

end.